import { z, createRoute, OpenAPIHono } from "@hono/zod-openapi";
import type { User } from "../../../../types/users.js";
import { verify } from "hono/jwt";

import { authMiddleware } from "../../../auth/middleware/authMiddleware.js";
import { updateSubModule } from "../../controller/module/updateSubModule.js";
import { apiHit } from "../../../../globalUtils/apiHits.js";

// Define the response schema
const responseSchema = z.object({
    message: z.string().optional(),
    module_id: z
        .string()
        .openapi({ example: "6c922c6c-7de3-4ec4-acb0-f068abdc" })
        .optional(),
    name: z.string().openapi({ example: "Production" }).optional(),
    active: z.boolean().openapi({ example: true }).optional(),
    roles: z
        .string()
        .openapi({ example: `["viewer","technician"]` })
        .optional(),
});

const app = new OpenAPIHono();

const ParamsSchema = z.object({
    id: z
        .string()
        .min(3)
        .openapi({
            param: {
                name: "id",
                in: "path",
            },
            example: "1212121",
        }),
});

app.openapi(
    createRoute({
        tags: ["server"],
        summary: "Updates submodule",
        method: "patch",
        path: "/submodules/{id}",
        middleware: authMiddleware,
        request: {
            params: ParamsSchema,
        },
        responses: {
            200: {
                content: {
                    "application/json": { schema: responseSchema },
                },
                description: "Response message",
            },
            400: {
                content: {
                    "application/json": {
                        schema: z.object({
                            message: z
                                .string()
                                .optional()
                                .openapi({ example: "Internal Server error" }),
                        }),
                    },
                },
                description: "Internal Server Error",
            },
            401: {
                content: {
                    "application/json": {
                        schema: z.object({
                            message: z
                                .string()
                                .optional()
                                .openapi({ example: "Unauthenticated" }),
                        }),
                    },
                },
                description: "Unauthorized",
            },
            500: {
                content: {
                    "application/json": {
                        schema: z.object({
                            message: z
                                .string()
                                .optional()
                                .openapi({ example: "Internal Server error" }),
                        }),
                    },
                },
                description: "Internal Server Error",
            },
        },
    }),
    async (c) => {
        const { id } = c.req.valid("param");

        // make sure we have a vaid user being accessed thats really logged in
        const authHeader = c.req.header("Authorization");

        const token = authHeader?.split("Bearer ")[1] || "";
        let user: User;

        try {
            const payload = await verify(token, process.env.JWT_SECRET!);
            user = payload.user as User;
        } catch (error) {
            return c.json({ message: "Unauthorized" }, 401);
        }

        // now pass all the data over to update the user info
        try {
            const data = await c?.req.json();
            apiHit(c, {
                endpoint: `/submodules/${id}`,
                action: "just updates submodules",
                lastBody: data,
            });
            await updateSubModule(data, id ?? "");
            return c.json({ success: true, message: "Module Updated" }, 200);
        } catch (error) {
            return c.json(
                {
                    message: "Please make sure you are not missing your data.",
                    error,
                },
                400
            );
        }

        return c.json({
            message: `Module has been updated`,
            data: id,
        });
    }
);

export default app;
